///////////////////////////////////////////////////////////
////// GDXlib_X11.c
////// Released under LGPL see license.txt
////// Written by:
//////    Michael Gibson
//////    (c)2003-2004
///////////////////////////////////////////////////////////

#include "GDXlib_X11.h"
#include <X11/xpm.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "warning.xpm"
#include "information.xpm"

XWMHints        xwmh = {
    (InputHint|StateHint),        // flags 
    False,                        // input
    NormalState,                  // initial_state 
    0,                            // icon pixmap 
    0,                            // icon window 
    0, 0,                         // icon location 
    0,                            // icon mask 
    0,                            // Window group 
};


//////////////////////////////////////////////////////////
/////
///////////////////////////////////////////////////////////
int x_calbox(char *title)
{

  int x11return;

  GC          pen;              // GC to draw with -- grey pen
  XGCValues   pen_prop;         // Struct for creating GC
  GC          pen2;              // GC to draw with -- grey pen
  XGCValues   pen2_prop;         // Struct for creating GC
  int loop, loop2, linesplace;
  unsigned long fth;             // Font size parameters
  unsigned long   bd = X_DGREY;
  unsigned long   fg = X_BLACK;
  unsigned long   bg = X_GREY;
  unsigned long   bw = 1;
  XSizeHints  xsh;
  XFontStruct *fontstruct;       // Font descriptor -- all pens given same font
  XEvent      event;             // Event received

  if ((fontstruct = XLoadQueryFont(display, "fixed")) == NULL) {
      printf("Display doesn't know the font fixed\n");
      exit(1);
  }
  fth = fontstruct->max_bounds.ascent + fontstruct->max_bounds.descent;
  xsh.flags = (PPosition | PSize);

  xsh.height = 450;
  xsh.width = 450;

  xsh.x = (DisplayWidth(display, DefaultScreen(display)) - xsh.width) / 2;
  xsh.y = (DisplayHeight(display, DefaultScreen(display)) - xsh.height) / 2 + 50;
  pen_prop.font = fontstruct->fid;
  pen2_prop.font = fontstruct->fid;
  //set drawing color
  pen_prop.foreground = X_BLACK;
  pen_prop.background = X_GREY;
  pen2_prop.foreground = X_WHITE;
  pen2_prop.background = X_GREY;

  window = XCreateSimpleWindow(display,DefaultRootWindow(display),xsh.x,xsh.y,xsh.width,xsh.height,bw,bd,bg);
  XSetStandardProperties(display, window, title, title, None, NULL, 0, &xsh);
  pen = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen_prop);
  pen2 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen2_prop);
  XSelectInput(display, window, EVENT_MASK);
  XMapWindow(display, window); //show window
  while (1) {
   XNextEvent(display, &event);
    if (event.type == ButtonPress){
         XDestroyWindow(display,window);
         break;
    }
   if (event.type == KeyPress){
         XDestroyWindow(display,window);
         break;
   }
   if (event.type == Expose && event.xexpose.count == 0) {
       XWindowAttributes xwa;       // Temp Get Window Attribute struct
       while (XCheckTypedEvent(display, Expose, &event));
       if (XGetWindowAttributes(display, window, &xwa) == 0) break;
       XClearWindow(display, window);
   }
  }
return x11return;
}

//////////////////////////////////////////////////////////
////// x_open();
//////////////////////////////////////////////////////////
void x_open()
{

    if ((display = XOpenDisplay(NULL)) == NULL) {
        printf("Can't open %s \n", XDisplayName(NULL));
        exit(1);
    }

}
////////////////////////////////////////////////////////////
////// x_close()
////////////////////////////////////////////////////////////
void x_close()
{

  XCloseDisplay(display);
}


////////////////////////////////////////////////////////////
//////
////color 0 none
////color 1 altering light green
////color 2 altering white and light gray
///////////////////////////////////////////////////////////
void x_slistwindow(int width, int height, char *title, int color, char hilight, int numberoflines, char lines[512][512], char *font, char *head)
{
  GC          pen;              // GC to draw with -- grey pen
  XGCValues   pen_prop;         // Struct for creating GC
  GC          pen2;              // GC to draw with -- grey pen
  XGCValues   pen2_prop;         // Struct for creating GC
  GC          pen3;              // GC to draw with -- grey pen
  XGCValues   pen3_prop;         // Struct for creating GC
  GC          pen4;              // GC to draw with -- grey pen
  XGCValues   pen4_prop;         // Struct for creating GC

  GC          pen5;              // GC to draw with -- grey pen
  XGCValues   pen5_prop;         // Struct for creating GC

  int loop, loop2, linesplace;
  unsigned long fth;             // Font size parameters
  unsigned long   bd = X_DGREY;
  unsigned long   fg = X_BLACK;
  unsigned long   bg = X_GREY;
  unsigned long   bw = 1;
  XSizeHints  xsh;
  XFontStruct *fontstruct;       // Font descriptor -- all pens given same font
  XEvent      event;             // Event received
  if ((fontstruct = XLoadQueryFont(display, font)) == NULL) {
      printf("Display %s doesn't know the font '%s'\n", DisplayString(display), font);
      exit(1);
  }
  fth = fontstruct->max_bounds.ascent + fontstruct->max_bounds.descent;
  xsh.flags = (PPosition | PSize);
  xsh.height = height;
  xsh.width = width;
  xsh.x = (DisplayWidth(display, DefaultScreen(display)) - xsh.width) / 2;
  xsh.y = (DisplayHeight(display, DefaultScreen(display)) - xsh.height) / 2 + 50;

  pen_prop.font = fontstruct->fid;
  pen2_prop.font = fontstruct->fid;
  pen3_prop.font = fontstruct->fid;
  pen4_prop.font = fontstruct->fid;
  pen5_prop.font = fontstruct->fid;

  //set drawing color
  pen_prop.foreground = X_BLACK;
  pen_prop.background = X_GREY;

  pen2_prop.foreground = X_WHITE;
  pen2_prop.background = X_GREY;

  pen3_prop.foreground = X_LGREEN;
  pen3_prop.background = X_GREY;

  pen4_prop.foreground = X_LLGREEN;
  pen4_prop.background = X_GREY;

  pen5_prop.foreground = X_YELLOW;
  pen5_prop.background = X_GREY;

  window = XCreateSimpleWindow(display,DefaultRootWindow(display),xsh.x,xsh.y,xsh.width,xsh.height,bw,bd,bg);
  XSetStandardProperties(display, window, title, title, None, NULL, 0, &xsh);
  pen = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen_prop);
  pen2 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen2_prop);
  pen3 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen3_prop);
  pen4 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen4_prop);
  pen5 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen5_prop);
  XSelectInput(display, window, EVENT_MASK);
  XMapWindow(display, window); //show window
  while (1) {
   XNextEvent(display, &event);
    if (event.type == ButtonPress){
         XDestroyWindow(display,window);
         break;
    }
   if (event.type == KeyPress){
         XDestroyWindow(display,window);
         break;
   }
   if (event.type == Expose && event.xexpose.count == 0) {
       XWindowAttributes xwa;       // Temp Get Window Attribute struct 
       while (XCheckTypedEvent(display, Expose, &event));
       if (XGetWindowAttributes(display, window, &xwa) == 0) break;
       XClearWindow(display, window);
       linesplace=30;
       XDrawString(display, window, pen,  5 ,10, head, strlen(head));
       XDrawLine(display, window, pen, 1, 12, width-6, 12);
       for(loop=0;loop<numberoflines;loop++){
         //printf("%s\n",lines[loop]);


         if(loop % 2 == 0){ //if even line 

           if(color==1){    //if color scheme 1

             for(loop2=-12;loop2<2;loop2++){
               if(lines[loop][0]!=hilight)XDrawLine(display,window,pen3,0,linesplace+loop2,width - 6,linesplace+loop2);
               else XDrawLine(display,window,pen5,0,linesplace+loop2,width - 6,linesplace+loop2);
             }//end for

            }//end color 1

           if(color==2){  //if color scheme 2

             for(loop2=-12;loop2<2;loop2++){

               //if no hilight color draw color scheme (white) background
               if(lines[loop][0]!=hilight)XDrawLine(display,window,pen2,0,linesplace+loop2,width - 6,linesplace+loop2);

               //else draw yellow background
               else XDrawLine(display,window,pen5,0,linesplace+loop2,width - 6,linesplace+loop2);

             }//end for loop

            }//end color 2
            XDrawString(display, window, pen,  5 ,linesplace, lines[loop], strlen(lines[loop]));
         }
         else{ //if odd place white background on list
           if(color==1){
             for(loop2=-12;loop2<2;loop2++){
               if(lines[loop][0]!=hilight)XDrawLine(display,window,pen4,0,linesplace+loop2,width - 6,linesplace+loop2);
               else XDrawLine(display,window,pen5,0,linesplace+loop2,width - 6,linesplace+loop2);
             }
           }//end color 1

          if(color==2){
             for(loop2=-12;loop2<2;loop2++){
               if(lines[loop][0]!=hilight) printf(" ");
               else XDrawLine(display,window,pen5,0,linesplace+loop2,width - 6,linesplace+loop2);
             }
           }//end color 2

           XDrawString(display, window, pen, 5 ,linesplace, lines[loop], strlen(lines[loop]));
         }
         linesplace=linesplace+14;
       }
      //box in the list
      linesplace=linesplace-13;
      XDrawLine(display, window, pen2, width-6 , 12         , width-6, linesplace);
      XDrawLine(display, window, pen2, 1       , linesplace , width-6, linesplace);
    }
  }
}


////////////////////////////////////////////////////////////
//////
///////////////////////////////////////////////////////////
void x_graphwindow(int width, int height, char *title, int numberofbars, int *bars, char *font)
{
  GC          pen;              // GC to draw with -- grey pen
  XGCValues   pen_prop;         // Struct for creating GC
  GC          pen2;              // GC to draw with -- grey pen
  XGCValues   pen2_prop;         // Struct for creating GC
  char numberst[10];
  int loop, barplace;
  unsigned long fth;             // Font size parameters
  unsigned long   bd = X_DGREY;
  unsigned long   fg = X_BLACK;
  unsigned long   bg = X_GREY;
  unsigned long   bw = 1;
  XSizeHints  xsh;
  XFontStruct *fontstruct;       // Font descriptor -- all pens given same font
  XEvent      event;             // Event received
  if ((fontstruct = XLoadQueryFont(display, font)) == NULL) {
      printf("Display %s doesn't know the font '%s'\n", DisplayString(display), font);
      exit(1);
  }
  fth = fontstruct->max_bounds.ascent + fontstruct->max_bounds.descent;
  xsh.flags = (PPosition | PSize);
  xsh.height = height;
  xsh.width = width;
  xsh.x = (DisplayWidth(display, DefaultScreen(display)) - xsh.width) / 2;
  xsh.y = (DisplayHeight(display, DefaultScreen(display)) - xsh.height) / 2 + 50;
  pen_prop.font = fontstruct->fid;
  pen2_prop.font = fontstruct->fid;
  //set drawing color
  pen_prop.foreground = X_BLUE;
  pen_prop.background = X_GREY;
  pen2_prop.foreground = X_BLACK;
  pen2_prop.background = X_GREY;
  window = XCreateSimpleWindow(display,DefaultRootWindow(display),xsh.x,xsh.y,xsh.width,xsh.height,bw,bd,bg);
  XSetStandardProperties(display, window, title, title, None, NULL, 0, &xsh);
  pen = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen_prop);
  pen2 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen2_prop);
  XSelectInput(display, window, EVENT_MASK);
  XMapWindow(display, window); //show window
  while (1) {
   XNextEvent(display, &event);
    if (event.type == ButtonPress){
         XDestroyWindow(display,window);
         break;
    }
   if (event.type == KeyPress){
         XDestroyWindow(display,window);
         break;
   }
   if (event.type == Expose && event.xexpose.count == 0) {
       XWindowAttributes xwa;       // Temp Get Window Attribute struct 
       while (XCheckTypedEvent(display, Expose, &event));
       if (XGetWindowAttributes(display, window, &xwa) == 0) break;
       XClearWindow(display, window);
       barplace=10;
       for(loop=0;loop<numberofbars;loop++){
         XDrawLine(display, window, pen2, 1, barplace, bars[loop], barplace);
         XDrawLine(display, window, pen, 1, barplace+1, bars[loop], barplace+1);
         XDrawLine(display, window, pen, 1, barplace+2, bars[loop], barplace+2);
         XDrawLine(display, window, pen, 1, barplace+3, bars[loop], barplace+3);
         XDrawLine(display, window, pen, 1, barplace+4, bars[loop], barplace+4);
         XDrawLine(display, window, pen2, 1, barplace+5, bars[loop], barplace+5);
         sprintf(numberst,"$%d",bars[loop]);
         XDrawString(display, window, pen2, 5 ,barplace, numberst, strlen(numberst));
         barplace=barplace+20;
       }
    }
  }
}
////////////////////////////////////////////////
////// x_msgbox()
///////////////////////////////////////////////
void x_msgbox(int type, char *disp_string, char *title, char *font, int padding)
{

    GC          pen1;              // GC to draw with -- white pen 
    GC          pen2;              // GC to draw with -- grey pen
    GC          pen3;              // GC to draw with -- dark grey pen
    GC          pen4;              // GC to draw with -- yellow pen
    GC          pen5;              // GC to draw with -- black pen
    GC          gcpixmap;
    XGCValues   pen1_prop;         // Struct for creating GC
    XGCValues   pen2_prop;         // Struct for creating GC 
    XGCValues   pen3_prop;         // Struct for creating GC
    XGCValues   pen4_prop;         // Struct for creating GC
    XGCValues   pen5_prop;         // Struct for creating GC
    XGCValues   pixmap_prop;
    Pixmap      pixmap,mask;
    XpmAttributes attributes;
    XpmColorSymbol xpmcolor[1];
    XFontStruct *fontstruct;       // Font descriptor -- all pens given same font 
    unsigned long fth;             // Font size parameters 
    unsigned long fg, bg, bd;      // Pixel values 
    unsigned long bw;              // Border width 
    XEvent      event;             // Event received 
    XSizeHints  xsh;               // Size hints for window manager 
    char       *geomSpec;          // Window geometry string 
    XSetWindowAttributes xswa;     // Temporary Set Window Attribute struct 
    int x, y;                      // label text positons
    int x2,x3;                     // button text positions
    int loop=0,loop2=0;

     // type 0=plain,1=plain-ok,2=smile-ok,3=smile,4=warn-ok

    if(strcmp(font,"DEFAULT")==0)strcpy(font,"fixed");

    if ((fontstruct = XLoadQueryFont(display, font)) == NULL) {
        printf("Display %s doesn't know the font '%s' ::GDXlib\n", DisplayString(display), font);
        exit(1);
    }
    fth = fontstruct->max_bounds.ascent + fontstruct->max_bounds.descent;

    bd = X_DGREY;
    fg = X_BLACK;
    bg = X_GREY;
    bw = 1;

    xsh.flags = (PPosition | PSize);
    xsh.height = fth + padding * 2;
    xsh.width = XTextWidth(fontstruct, disp_string, strlen(disp_string)) + padding * 2;
    xsh.x = (DisplayWidth(display, DefaultScreen(display)) - xsh.width) / 2;
    xsh.y = (DisplayHeight(display, DefaultScreen(display)) - xsh.height) / 2 + 50;
    window = XCreateSimpleWindow(display,DefaultRootWindow(display),xsh.x,xsh.y,xsh.width,xsh.height,bw,bd,bg);
    XSetStandardProperties(display, window, title, title, None, NULL, 0, &xsh);
    xswa.colormap = DefaultColormap(display, DefaultScreen(display));
    xswa.bit_gravity = CenterGravity;
    XChangeWindowAttributes(display, window, (CWColormap | CWBitGravity), &xswa);

    // set all pens to same font
    pen1_prop.font = fontstruct->fid;
    pen2_prop.font = fontstruct->fid;
    pen3_prop.font = fontstruct->fid;
    pen4_prop.font = fontstruct->fid;
    pen5_prop.font = fontstruct->fid;

    //set drawing color
    pen1_prop.foreground = X_WHITE;
    pen2_prop.foreground = X_GREY;
    pen3_prop.foreground = X_DGREY;
    pen4_prop.foreground = X_YELLOW;
    pen5_prop.foreground = X_BLACK;

    pen1_prop.background = X_GREY;
    pen2_prop.background = X_GREY;
    pen3_prop.background = X_GREY;
    pen4_prop.background = X_GREY;
    pen5_prop.background = X_GREY;

    pen1 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen1_prop);
    pen2 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen2_prop);
    pen3 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen3_prop);
    pen4 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen4_prop);
    pen5 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen5_prop);
 

    if (type==4||type==5){
      attributes.valuemask = XpmColormap;
      attributes.x_hotspot = 0;
      attributes.y_hotspot = 0;
      attributes.depth = DefaultDepth(display, DefaultScreen(display));;
      attributes.colormap = DefaultColormap(display, DefaultScreen(display));
      pixmap_prop.function = GXcopy;
      pixmap_prop.plane_mask = AllPlanes;
      pixmap_prop.foreground = 0;
      gcpixmap = XCreateGC(display, window, GCForeground|GCFunction|GCPlaneMask, &pixmap_prop);
      attributes.valuemask = XpmSize;
      if(type==4)XpmCreatePixmapFromData(display, window, warning_xpm, &pixmap, &mask, &attributes);
      if(type==5)XpmCreatePixmapFromData(display, window, information_xpm, &pixmap, &mask, &attributes);
      XSetFillStyle(display, gcpixmap, FillTiled);
      XSetTile(display, gcpixmap, pixmap);
      XSetClipMask(display,gcpixmap,mask);
    }

    XSelectInput(display, window, EVENT_MASK);
    XMapWindow(display, window); //show window

    while (1) { //Loop forever,  examining each event.
        XNextEvent(display, &event);
        if (event.type == ButtonPress){
           XWindowAttributes xwa;       // Temp Get Window Attribute struct
           if(event.xbutton.x  >= (xwa.width/2)-24 && event.xbutton.y >= xwa.height-38){
             XDestroyWindow(display,window);
             break;
           }

        }
        if (event.type == Expose && event.xexpose.count == 0) {
            XWindowAttributes xwa;       // Temp Get Window Attribute struct 
            while (XCheckTypedEvent(display, Expose, &event));
            if (XGetWindowAttributes(display, window, &xwa) == 0) break;
            x = (xwa.width - XTextWidth(fontstruct, disp_string, strlen(disp_string))) / 2;
            x2= (xwa.width - XTextWidth(fontstruct, "OK", 2)) / 2;
            y = (xwa.height + fontstruct->max_bounds.ascent
                 - fontstruct->max_bounds.descent) / 2;
            XClearWindow(display, window);

            XDrawString(display, window, pen5, x, y, disp_string, strlen(disp_string));

            if (type==4||type==5){//insert pixmap
              XFillRectangle(display, window, gcpixmap, 0,0,40,40);
            } 
            if (type==2 || type==3){
              XFillArc(display, window, pen4, 10, 10,30,30,0,360*64);
              XDrawArc(display, window, pen5, 10, 10,30,30,0,360*64);

              XFillArc(display, window, pen5, 17, 15,5,5,0,360*64);
              XFillArc(display, window, pen5, 28, 15,5,5,0,360*64);
              // smile
              XDrawArc(display, window, pen5, 15, 15,20,20,0,-180*64);
            }
            if (type==1 || type==2|| type==4 || type==5){ //create ok button
              XFillRectangle(display, window, pen3, (xwa.width/2)-25 ,(xwa.height-40),50,30);
              XDrawLine(display,window,pen1,(xwa.width/2)-24,(xwa.height-39),(xwa.width/2)+24,(xwa.height-39));
              XDrawLine(display,window,pen1,(xwa.width/2)-23,(xwa.height-38),(xwa.width/2)+23,(xwa.height-38));
              XDrawLine(display,window,pen1,(xwa.width/2)-24,(xwa.height-39),(xwa.width/2)-24,(xwa.height-12));
              XFillRectangle(display, window, pen2, (xwa.width/2)-23 ,(xwa.height-37),46,24);
              XDrawString(display, window, pen5, x2 ,(xwa.height-20), "OK", 2);
            }   
        }
    }
}

////////////////////////////////////////////////
////// x_radiobox()
///////////////////////////////////////////////
//void x_radiobox(char *command)
int x_radiobox(char *radio1, char *radio2, char *disp_string, char *title, char *font, int padding)
{
                                                                                                                             
    GC          pen1;              // GC to draw with -- white pen
    GC          pen2;              // GC to draw with -- black pen
    GC          pen3; 
    XGCValues   pen1_prop;         // Struct for creating GC
    XGCValues   pen2_prop;         // Struct for creating GC
    XGCValues   pen3_prop; 
    XFontStruct *fontstruct;       // Font descriptor -- all pens given same font
    unsigned long fth;             // Font size parameters
    unsigned long fg, bg, bd;      // Pixel values
    unsigned long bw;              // Border width
    XEvent      event;             // Event received
    XSizeHints  xsh;               // Size hints for window manager
    char       *geomSpec;          // Window geometry string
    XSetWindowAttributes xswa;     // Temporary Set Window Attribute struct
    int xbutton, ybutton;   
    int x, y;                      // label text positons
    int x2,x3;                     // radio text positions
    int loop=0,loop2=0;
                                                                                             
    if(strcmp(font,"DEFAULT")==0)strcpy(font,"fixed");
                                                                                                                             
    if ((fontstruct = XLoadQueryFont(display, font)) == NULL) {
        printf("Display %s doesn't know the font '%s'\n", DisplayString(display), font);
        exit(1);
    }
    fth = fontstruct->max_bounds.ascent + fontstruct->max_bounds.descent;
                                                                                                                             
    bd = X_DGREY;
    fg = X_BLACK;
    bg = X_GREY;
    bw = 1;
                                                                                                                             
    xsh.flags = (PPosition | PSize);
    xsh.height = fth + padding * 2;
    xsh.width = XTextWidth(fontstruct, disp_string, strlen(disp_string)) + padding * 2;
    xsh.x = (DisplayWidth(display, DefaultScreen(display)) - xsh.width) / 2;
    xsh.y = (DisplayHeight(display, DefaultScreen(display)) - xsh.height) / 2 + 50;
    window = XCreateSimpleWindow(display,DefaultRootWindow(display),xsh.x,xsh.y,xsh.width,xsh.height,bw,bd,bg);
    XSetStandardProperties(display, window, title, title, None, NULL, 0, &xsh);
    xswa.colormap = DefaultColormap(display, DefaultScreen(display));
    xswa.bit_gravity = CenterGravity;
    XChangeWindowAttributes(display, window, (CWColormap | CWBitGravity), &xswa);
                                                                                                                             
    // set all pens to same font
    pen1_prop.font = fontstruct->fid;
    pen2_prop.font = fontstruct->fid;
    pen3_prop.font = fontstruct->fid;
                                                                                                                             
    //set drawing color
    pen1_prop.foreground = X_WHITE;
    pen2_prop.foreground = X_BLACK;
    pen3_prop.foreground = X_DGREY;
 
    pen1_prop.background = X_GREY;
    pen2_prop.background = X_GREY;
    pen3_prop.background = X_GREY;                                                                                                                         
    pen1 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen1_prop);
    pen2 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen2_prop);
    pen3 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen3_prop);                                                                                                                         
    XSelectInput(display, window, EVENT_MASK);
    XMapWindow(display, window); //show window

    while (1) { //Loop forever,  examining each event.
        XNextEvent(display, &event);
        if (event.type == ButtonPress){
             xbutton=event.xbutton.x;
             ybutton=event.xbutton.y;
             if(ybutton <= y+20 && ybutton >= y+10) {
                X11return=1;
                XDestroyWindow(display,window);
                break;
             }
             if(ybutton <= y+40 && ybutton >= y+30) { 
                X11return=2;
                XDestroyWindow(display,window);
                break;
             }
        }
        if (event.type == Expose && event.xexpose.count == 0) {
            XWindowAttributes xwa;       // Temp Get Window Attribute struct
            while (XCheckTypedEvent(display, Expose, &event));
            if (XGetWindowAttributes(display, window, &xwa) == 0) break;

            //find placement
            x = (xwa.width - XTextWidth(fontstruct, disp_string, strlen(disp_string))) / 2;
            x2= (xwa.width - XTextWidth(fontstruct, radio1     , strlen(radio1     ))) / 2;
            x3= (xwa.width - XTextWidth(fontstruct, radio2     , strlen(radio2     ))) / 2;
            y = (xwa.height + fontstruct->max_bounds.ascent
                 - fontstruct->max_bounds.descent) / 2;
            XClearWindow(display, window);

            //check to see which radio will get aligned with which. 
            if(x2<<x3)x3=x2;
            if(x3<<x2)x2=x3;                            

            //Draw label                                                                                     
            XDrawString(display, window, pen2, x, y, disp_string, strlen(disp_string));

            //Draw radios
            XFillArc(display, window, pen3, x2-21, y+4, 15,15,0,360*64);
            XFillArc(display, window, pen1, x2-20, y+5, 15,15,0,360*64);
            XDrawString(display, window, pen2, x2, y+20, radio1, strlen(radio1 ));
            XFillArc(display, window, pen3, x3-21, y+24 ,15,15,0,360*64);
            XFillArc(display, window, pen1, x3-20, y+25 ,15,15,0,360*64); 
            XDrawString(display, window, pen2, x3, y+40, radio2, strlen(radio2 ));
        }
    }
  return X11return;
}
////////////////////////////////////////////////////////
//////
////////////////////////////////////////////////////////

int x_imgbox(char *filename,char *title)

{
    GC   pen[500];            // GC to draw with -- black pen
    GC   gcP;
    Pixmap mask, pm, pmP;
    Drawable drawpm;
    XpmAttributes attributes;
    XpmColorSymbol xpmcolor[1];
    XGCValues pen_prop;       // Struct for creating GC
    XGCValues PM_prop;
    XFontStruct *fontstruct;       // Font descriptor -- all pens given same font
    unsigned long fth;             // Font size parameters
    unsigned long fg, bg, bd;      // Pixel values
    unsigned long bw;              // Border width
    XEvent      event;             // Event received
    XSizeHints  xsh;               // Size hints for window manager
    char       *geomSpec;          // Window geometry string
    XSetWindowAttributes xswa;     // Temporary Set Window Attribute struct
    int loop=0,loop2=0,xbutton;
    char is_gpg[30];
    char *pppp;
    FILE *gfile; 
    int typedraw[500], numlines=0;
    int imageh=20,imagew=20;
    unsigned long color[500];
    char c_color[500][10];
    unsigned long b_color=X_GREY;
    char bc_color[10];
    int x1[500],x2[500],y1[500],y2[500];
                                                                                                                         
 
    gfile = fopen(filename,"r");

    fscanf(gfile,"%s",is_gpg);
    if(strncmp(is_gpg,"gpg",3)==0){ 
      fscanf(gfile,"%s%d%d%d",bc_color,&numlines,&imageh,&imagew);
      b_color = strtoul(bc_color,NULL,16);
      for(loop=0;loop<numlines;loop++){
        fscanf(gfile,"%d%s%d%d%d%d",&typedraw[loop],c_color[loop],&x1[loop],&y1[loop],&x2[loop],&y2[loop]);
        color[loop]= strtoul(c_color[loop],NULL,16);
      }
   }
    fclose(gfile);


    if ((fontstruct = XLoadQueryFont(display, "fixed")) == NULL) {
        printf("Display doesn't know the font 'fixed'\n");
        exit(1);
    }
    fth = fontstruct->max_bounds.ascent + fontstruct->max_bounds.descent;

    xsh.flags = (PPosition | PSize);
    window = XCreateSimpleWindow(display,DefaultRootWindow(display),50,50,imagew,imageh,1,X_DGREY,b_color);
    XSetStandardProperties(display, window, title, title, None, NULL, 0, &xsh);
    xswa.colormap = DefaultColormap(display, DefaultScreen(display));
    xswa.bit_gravity = CenterGravity;
    XChangeWindowAttributes(display, window, (CWColormap | CWBitGravity), &xswa);
    for(loop=0;loop<numlines;loop++){
      pen_prop.font = fontstruct->fid;
      pen_prop.foreground = color[loop];
      pen_prop.background = b_color;
      pen[loop] = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen_prop);
    }

   if(strncmp(is_gpg,"gpg",3)!=0){
     attributes.valuemask = XpmColormap;
     attributes.x_hotspot = 0;
     attributes.y_hotspot = 0;
     attributes.depth = DefaultDepth(display, DefaultScreen(display));;
     attributes.colormap = DefaultColormap(display, DefaultScreen(display)); 
     PM_prop.function = GXcopy;
     PM_prop.plane_mask = AllPlanes;
     PM_prop.foreground = 0;
     gcP = XCreateGC(display, window, GCForeground|GCFunction|GCPlaneMask, &PM_prop);
     attributes.valuemask = XpmSize;
     XpmReadFileToPixmap(display,window,filename,&pmP,&mask,&attributes);
     XSetFillStyle(display, gcP, FillTiled);
     XSetTile(display, gcP, pmP);
     XSetClipMask(display,gcP,mask);
     imagew=attributes.width;
     imageh=attributes.height;
     XResizeWindow(display, window, imagew, imageh);
   }
    XSelectInput(display, window, EVENT_MASK);
    XMapWindow(display, window); //show window

    while (1) { //Loop forever,  examining each event.
        XNextEvent(display, &event);
        if (event.type == ButtonPress){
             xbutton=event.xbutton.x;
             XDestroyWindow(display,window);
             break;
        }
        if (event.type == KeyPress){
             //xbutton=event.xbutton.x;
             //XDestroyWindow(display,window);
              printf("%d\n",event.xkey.keycode);
             //break;
        }

        if (event.type == Expose && event.xexpose.count == 0) {
            XWindowAttributes xwa;       // Temp Get Window Attribute struct
            while (XCheckTypedEvent(display, Expose, &event));
            if (XGetWindowAttributes(display, window, &xwa) == 0) break;
            XClearWindow(display, window);
             if(strncmp(is_gpg,"gpg",3)!=0){
               XFlush(display);
               XFillRectangle(display, window, gcP, 0,0,attributes.width + 2,attributes.height +2); 
             }
             else{
               for(loop=0;loop<numlines;loop++){
                 if(typedraw[loop]==1)XDrawLine(display,window,pen[loop],x1[loop],y1[loop],x2[loop],y2[loop]);
                 if(typedraw[loop]==2)XFillRectangle(display, window, pen[loop],x1[loop],y1[loop],x2[loop],y2[loop]);
               }
             }
        }
    }
    return xbutton;
}

//////////////////////////////////////////////////////
// x_imgkeybox
// specialized keyboard input box
//
////////////////////////////////////////////////////////
int x_imgkeybox(char *filename, char *title, int inputtype, int xcord, int ycord)

{
    GC   pen[500];            // GC to draw with -- black pen
    GC   gcP;
    GC          pen2;              // GC to draw with -- black pen
    XGCValues   pen2_prop;         // Struct for creating GC
    Pixmap mask, pm, pmP;
    Drawable drawpm;
    XpmAttributes attributes;
    XpmColorSymbol xpmcolor[1];
    XGCValues PM_prop;
    XFontStruct *fontstruct;       // Font descriptor -- all pens given same font
    unsigned long fth;             // Font size parameters
    unsigned long fg, bg, bd;      // Pixel values
    unsigned long bw;              // Border width
    XEvent      event;             // Event received
    XSizeHints  xsh;               // Size hints for window manager
    char       *geomSpec;          // Window geometry string
    XSetWindowAttributes xswa;     // Temporary Set Window Attribute struct
    int loop=0,loop2=0,x11return;
    char *pppp;
    FILE *gfile;
    int typedraw[500], numlines=0;
    int imageh=20,imagew=20;
    int place;
    unsigned long color[500];
    char c_color[500][10];
    unsigned long b_color=X_GREY;
    char bc_color[10];
    int x1[500],x2[500],y1[500],y2[500];
    char numberstring[8];
    int input_num;


    strcpy(numberstring,"\0");

    //format
    // '[image],[title],[inputtype],[xcord],[ycord]'


    //input type 1 allows 1234567890ed
    //                    up to 6 numbers or 1 'e' or 1 'd'
    //                    echo output
    //input type 2 allows 1234567890.
    //                    up to 9 numbers/decimals
    //                    echo output 
    //input type 3 allows 1234567890abcdefghijklmnopqrstuvwxyz
    //                    up to 1 character
    //                    echo output                   


   //debug purpose
   printf("xcord , ycord %d , %d \n",xcord,ycord);


   if ((fontstruct = XLoadQueryFont(display, "fixed")) == NULL) {
        printf("Display doesn't know the font 'fixed'\n");
        exit(1);
    }
    fth = fontstruct->max_bounds.ascent + fontstruct->max_bounds.descent;

    xsh.flags = (PPosition | PSize);
    window = XCreateSimpleWindow(display,DefaultRootWindow(display),50,50,imagew,imageh,1,X_DGREY,b_color);
    XSetStandardProperties(display, window, title, title, None, NULL, 0, &xsh);
    xswa.colormap = DefaultColormap(display, DefaultScreen(display));
    xswa.bit_gravity = CenterGravity;
    XChangeWindowAttributes(display, window, (CWColormap | CWBitGravity), &xswa);

    attributes.valuemask = XpmColormap;
    attributes.x_hotspot = 0;
    attributes.y_hotspot = 0;
    attributes.depth = DefaultDepth(display, DefaultScreen(display));;
    attributes.colormap = DefaultColormap(display, DefaultScreen(display));
    PM_prop.function = GXcopy;
    PM_prop.plane_mask = AllPlanes;
    PM_prop.foreground = 0;

    // set all pens to same font
    pen2_prop.font = fontstruct->fid;

    //set drawing color
    pen2_prop.foreground = X_BLACK;
    pen2_prop.background = X_GREY;

    pen2 = XCreateGC(display, window, (GCFont | GCForeground | GCBackground), &pen2_prop);

    gcP = XCreateGC(display, window, GCForeground|GCFunction|GCPlaneMask, &PM_prop);

    attributes.valuemask = XpmSize;
    XpmReadFileToPixmap(display,window,filename,&pmP,&mask,&attributes);
    XSetFillStyle(display, gcP, FillTiled);
    XSetTile(display, gcP, pmP);
    XSetClipMask(display,gcP,mask);
    imagew=attributes.width;
    imageh=attributes.height;
    XResizeWindow(display, window, imagew, imageh);

    XSelectInput(display, window, EVENT_MASK);
    XMapWindow(display, window); //show window

    place=0;

   if(inputtype==1) input_num=60;
   if(inputtype==2) input_num=90;
   if(inputtype==3) input_num=10;

    while (1) { //Loop forever,  examining each event.
        XNextEvent(display, &event);
        if (event.type == KeyPress){
             //printf("%d\n",event.xkey.keycode);
             if(event.xkey.keycode == 36 ){
               x11return=atoi(numberstring);
               //debug only
               printf("numberstring='%s' x11return=%d\n",numberstring,x11return); 
               break;
             }
             if( place >= input_num){
                x11return=atoi(numberstring);
                //debug only
                printf("numberstring='%s' x11return=%d\n",numberstring,x11return);
                break;
             }

             if(inputtype==1 || inputtype==2 || inputtype==3){
               if(event.xkey.keycode == 10 ){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "1", 1);
                 strcat(numberstring,"1");
               }
               if(event.xkey.keycode == 11){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "2", 1);
                 strcat(numberstring,"2");
               }
               if(event.xkey.keycode == 12){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "3", 1);
                 strcat(numberstring,"3");
               }
               if(event.xkey.keycode == 13){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "4", 1);
                 strcat(numberstring,"4");
               }
               if(event.xkey.keycode == 14){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "5", 1);
                 strcat(numberstring,"5");
               }
               if(event.xkey.keycode == 15){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "6", 1);
                 strcat(numberstring,"6");
               }
               if(event.xkey.keycode == 16){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "7", 1);
                 strcat(numberstring,"7");
               }
               if(event.xkey.keycode == 17){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "8", 1);
                 strcat(numberstring,"8");
               }
               if(event.xkey.keycode == 18){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "9", 1);
                 strcat(numberstring,"9");
               }
               if(event.xkey.keycode == 19){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "0", 1);
                 strcat(numberstring,"0");
               }
            }// end if input type is 1,2,or3
             if(inputtype==1 ){
               if(event.xkey.keycode == 26 ){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "E", 1);
                 XDrawString(display, window, pen2, xcord + place+10, ycord, "T", 1);
                 XDrawString(display, window, pen2, xcord + place+20, ycord, "F", 1);
                 strcat(numberstring,"-1");
                 place=100;
               }
               if(event.xkey.keycode == 40 ){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "D", 1);
                 XDrawString(display, window, pen2, xcord + place+10, ycord, "E", 1);
                 XDrawString(display, window, pen2, xcord + place+20, ycord, "P", 1);
                 strcat(numberstring,"-2");
                 place=100;
               }
             }//end input type 1 only
             if(inputtype==2){
               if(event.xkey.keycode == 60 ){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, ".", 1);
                 strcat(numberstring,".");
               }
             }//end input type 2 only
            if(inputtype==3){
               if(event.xkey.keycode == 38 ){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "a", 1);
                 strcat(numberstring,"-38");
               }
               if(event.xkey.keycode == 56){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "b", 1);
                 strcat(numberstring,"-56");
               }
               if(event.xkey.keycode == 54){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "c", 1);
                 strcat(numberstring,"-54");
               }
               if(event.xkey.keycode == 40){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, ycord, "d", 1);
                 strcat(numberstring,"-40");
               }
               if(event.xkey.keycode == 26){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, 120, "e", 1);
                 strcat(numberstring,"-26");
               }
               if(event.xkey.keycode == 41){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, 120, "f", 1);
                 strcat(numberstring,"-41");
               }
               if(event.xkey.keycode == 42){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, 120, "g", 1);
                 strcat(numberstring,"-42");
               }
               if(event.xkey.keycode == 43){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, 120, "h", 1);
                 strcat(numberstring,"-43");
               }
               if(event.xkey.keycode == 31){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, 120, "i", 1);
                 strcat(numberstring,"-31");
               }
               if(event.xkey.keycode == 44){
                 place=place + 10;
                 XDrawString(display, window, pen2, xcord + place, 120, "j", 1);
                 strcat(numberstring,"-44");
               }
            }// end if input type is 3

        }//end keypress

        if (event.type == Expose && event.xexpose.count == 0) {
            XWindowAttributes xwa;       // Temp Get Window Attribute struct
            while (XCheckTypedEvent(display, Expose, &event));
            if (XGetWindowAttributes(display, window, &xwa) == 0) break;
            XClearWindow(display, window);
            XFlush(display);
            XFillRectangle(display, window, gcP, 0,0,attributes.width + 2,attributes.height +2);
        }
    }
  

    return x11return;
}




