///////////////////////////////////////////////////
/// GDX GEDCOM List
/// 0.0.1 Initial Release
/// 0.1.0 General working release
/// 0.2.0 bug fix
/// 0.3.0 works with other modules
/// 0.3.1 made to work with new individual displayer
/// Written By Michael Gibson under the GPL
/// (c) 2003 - 2007
//////////////////////////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

int button_01,button_02,button_03,button_04,button_05,selectlist;
int downbutton,upbutton;
char namelist[512][512];
char *r_version="0.3.1";
int selectrow=0;
void print_report(void);
int indi;
char last_action[5];
char filename[50];
char indi_name[200];
int number_of_names=0;
int x=0;
char temp[200];
FILE *fp;

////////////////////////////////
///far up list
///////////////////////////////
void faruplist(void){

  gdx_selectlist_obj.position[selectlist]=0;

}

///////////////////////////////
///far down list
//////////////////////////////
void fardownlist(void){

  int listpos;

   //511 max entries - 35 rows + 1 = 477 

  if(number_of_names < 477){ 
     listpos=number_of_names-34;
  }
  else{ 
     listpos=477;
  }

  gdx_selectlist_obj.position[selectlist]=listpos;

}

/////////////////////////////////////////////
///// showdata
////////////////////////////////////////////
void showdata(void){
  char systemstring[300];
  char istring[150];
  char istring2[6];
  int xxx;
  sprintf(istring,"%s",gdx_selectlist_obj.item[gdx_selectlist_obj.selected[selectlist]][selectlist]);
  strcpy(istring2,"     "); 
  for(xxx=0;xxx<6;xxx++){
    istring2[xxx]=istring[xxx];
  }
  istring2[xxx]='\0';
  printf("./gedindi %s %s &\n",filename,istring2);
  sprintf(systemstring,"./gedindi %s %s &",filename,istring2);
  system(systemstring);
}


/////////////////////////////////////////////
///// parent 
////////////////////////////////////////////
void parent(void){
  char systemstring[300];
  char istring[150];
  char istring2[6];
  int xxx;
  sprintf(istring,"%s",gdx_selectlist_obj.item[gdx_selectlist_obj.selected[selectlist]][selectlist]);
  xxx=0;
  for(xxx=0;xxx<6;xxx++){
    istring2[xxx]=istring[xxx];
  }
 istring2[xxx]='\0';
  printf("./gedtree %s %s &\n",filename,istring2);
  sprintf(systemstring,"./gedtree %s %s &",filename,istring2);
  system(systemstring);
}






////////////////////////////////////
//// load report module
///////////////////////////////////
void l_report(void){
   char systemstring[50];

   sprintf(systemstring,"./gedreport %s -h &",filename);
   system(systemstring);
}

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}

//////////////////////////////////////////
/// int main()
/////////////////////////////////////////
int main(int argc, char **argv)
{

  char stringnumofnames[10];
  int label1,label2;
 
  if(argc==2){ 
    sprintf(filename,"%s",argv[1]); }
  else{ 
    printf("No filename specified\n");
    exit(0);
  }
                                                                                                                             
  x_open(); 
                                                                                                                             
  /* create a new window */
  gdx_window("GEDCOM List",525,400); 
  gdx_setwindowbg("bg.xpm",1);

  button_01 = gdx_imagebutton(5,25,"close.xpm",destroy);
  button_02 = gdx_imagebutton(5,50,"list.xpm",print_report);
  button_03 = gdx_imagebutton(5,75,"hnew.xpm",l_report);
  button_04 = gdx_imagebutton(5,100,"viewi.xpm",showdata);
  button_05 = gdx_imagebutton(5,125,"pari.xpm",parent);

  upbutton  = gdx_imagebutton(500,23,"uup.xpm",faruplist);
  downbutton= gdx_imagebutton(500,360,"ddown.xpm",fardownlist);

  print_report();

  label1=gdx_label("Number of individuals:",35,15,0);
  gdx_setlabelbg("bg.xpm",1,label1);

  sprintf(stringnumofnames,"%d",number_of_names);
  label2=gdx_label(stringnumofnames,175,15,1);
  gdx_setlabelbg("white.xpm",1,label2);
  selectlist = gdx_selectlist(35,25,512,namelist,45,35);

  gdx_main ();
  x_close();
  return(0);
}


//////////////////////////////////////////
/// print_report()
/////////////////////////////////////////
void print_report()
{


  if((fp=fopen(filename,"r"))==NULL ){
     printf("GEDCOM list: Sorry, no file found. \n");
     exit(0);
  }


   number_of_names=-1;
  
do{
  fgets(temp,80,fp);

    for(x=0;x<50;x++){
      if(temp[x]=='\r' || temp[x]=='\n'){
         temp[x]= ' ';
      }
    }


  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){         //Individual 0 level start of record
      temp[0]=' ';
      for(x=0;x<80;x++) if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';
      indi=atoi(temp);
  }

  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A'){     ///1 NAME
     number_of_names++;
     for(x=7;x<80;x++){temp[x-7]=temp[x];} 
     if(indi >=1){
        sprintf(indi_name,"%04d %s",indi,temp);
     }
     else{
        sprintf(indi_name,"Submitted by: %s",temp);
     }
     strcpy(namelist[number_of_names],indi_name);
  }


  if(temp[0]=='2' && temp[2]=='D' && temp[3]=='A'){   ///2 DATE
     for(x=7;x<80;x++){temp[x-7]=temp[x];}

     if(last_action[0]=='B' && last_action[1]=='I'){
       sprintf(indi_name, "%s (%s -",indi_name,temp);
       strcpy(namelist[number_of_names],indi_name);
     }
     if(last_action[0]=='D' && last_action[1]=='E'){
       sprintf(indi_name, "%s %s)",indi_name,temp);
       strcpy(namelist[number_of_names],indi_name);
     }

  }


  if(temp[0]=='1' && temp[2]=='B' && temp[3]=='I'){ //1 BIRT
     strcpy(last_action,"BIRT");
  }
                                                                                                                             
  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='E' && temp[4] =='A'){ //1 DEAT
     strcpy(last_action,"DEAT");
  }

  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H'){ //1 CHAN
     strcpy(last_action,"CHAN");

  }

}while(temp[0] !='0' || temp[2] !='T');


fclose(fp);

}
